# Copyright (c) [2024] []
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

from typing import Final

import numpy as np

# Pauli matrices
TAU_X: Final[np.array] = np.array([[0, 1], [1, 0]])
TAU_Y: Final[np.array] = np.array([[0, -1j], [1j, 0]])
TAU_Z: Final[np.array] = np.array([[1, 0], [0, -1]])
TAU_0: Final[np.array] = np.array([[1, 0], [0, 1]])


INFILE = ""
OUTFILE = ""
SCF_XCF_ORIENTATION = np.array([0, 0, 1])
REF_XCF_ORIENTATIONS = [
    dict(o=np.array([1, 0, 0]), vw=[np.array([0, 1, 0]), np.array([0, 0, 1])]),
    dict(o=np.array([0, 1, 0]), vw=[np.array([1, 0, 0]), np.array([0, 0, 1])]),
    dict(o=np.array([0, 0, 1]), vw=[np.array([1, 0, 0]), np.array([0, 1, 0])]),
]

KSET = 10
KDIRS = "xy"
EBOT = -15
ESET = 300
ESETP = 1000
PARALLEL_SOLVER_FOR_GK = False

DEFAULT_PARAMETERS = dict()
DEFAULT_PARAMETERS["INFILE"] = INFILE
DEFAULT_PARAMETERS["OUTFILE"] = OUTFILE
DEFAULT_PARAMETERS["SCF_XCF_ORIENTATION"] = np.array([0, 0, 1])
DEFAULT_PARAMETERS["REF_XCF_ORIENTATIONS"] = [
    dict(o=np.array([1, 0, 0]), vw=[np.array([0, 1, 0]), np.array([0, 0, 1])]),
    dict(o=np.array([0, 1, 0]), vw=[np.array([1, 0, 0]), np.array([0, 0, 1])]),
    dict(o=np.array([0, 0, 1]), vw=[np.array([1, 0, 0]), np.array([0, 1, 0])]),
]
DEFAULT_PARAMETERS["KSET"] = KSET
DEFAULT_PARAMETERS["KDIRS"] = KDIRS
DEFAULT_PARAMETERS["EBOT"] = EBOT
DEFAULT_PARAMETERS["ESET"] = ESET
DEFAULT_PARAMETERS["ESETP"] = ESETP
DEFAULT_PARAMETERS["PARALLEL_SOLVER_FOR_GK"] = PARALLEL_SOLVER_FOR_GK
